diff --git a/configure.ac b/configure.ac
index 7eace73..3c2d036 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1696,7 +1696,10 @@ AC_ARG_ENABLE(taglib,
     PKG_CHECK_MODULES(TAGLIB, taglib >= 1.5,
       [ VLC_ADD_PLUGIN([taglib])
         VLC_ADD_LIBS([taglib],[$TAGLIB_LIBS -lz])
-       VLC_ADD_CXXFLAGS([taglib],[$TAGLIB_CFLAGS]) ],
+       VLC_ADD_CXXFLAGS([taglib],[$TAGLIB_CFLAGS])
+       AC_LANG_PUSH(C++)
+       AC_CHECK_HEADERS([taglib/mp4coverart.h]) 
+       AC_LANG_POP],
       [AC_MSG_WARN(TagLib library not found)])
   ])
 
diff --git a/modules/meta_engine/taglib.cpp b/modules/meta_engine/taglib.cpp
index 4e25b50..02bc45b 100644
--- a/modules/meta_engine/taglib.cpp
+++ b/modules/meta_engine/taglib.cpp
@@ -322,7 +322,7 @@ static void ReadMetaFromXiph( Ogg::XiphComment* tag, demux_t* p_demux, demux_met
     vlc_meta_SetArtURL( p_meta, "attachment://cover" );
 }
 
-#ifdef TAGLIB_WITH_MP4
+#ifdef HAVE_TAGLIB_MP4COVERART_H
 static void ReadMetaFromMP4( MP4::Tag* tag, demux_t *p_demux, demux_meta_t *p_demux_meta, vlc_meta_t* p_meta )
 {
     if( tag->itemListMap().contains("covr") )
@@ -430,7 +430,7 @@ static int ReadMeta( vlc_object_t* p_this)
         else if( flac->xiphComment() )
             ReadMetaFromXiph( flac->xiphComment(), p_demux, p_demux_meta, p_meta );
     }
-#ifdef TAGLIB_WITH_MP4
+#ifdef HAVE_TAGLIB_MP4COVERART_H
     else if( MP4::File *mp4 = dynamic_cast<MP4::File*>(f.file()) )
     {
         if( mp4->tag() )
